
Inspect17 = {}; 
local InspectMOD_directory = g_currentModDirectory;
function Inspect17:loadMap(name) 

	local aNameSearch = {"vehicle.name." .. g_languageShort, "vehicle.name.en", "vehicle.name", "vehicle.storeData.name", "vehicle#type", "vehicle#className"};
	
	self.bDisplay = 1; 
	self.bDarkColor = 0; 
	self.fPosChanger = 0;
	self.fDisplayMode = 0;
	self.fHighlightMode = 0;
	self.fFontSize = 0.014;
	self.fFieldMode = 0;
	self.isDedi = Inspect17:checkIsDedi();
		
	Inspect17:loadConfig()
	
	if Inspect17.fieldsData == nil then
        Inspect17.fieldsData = {}
        Inspect17.buildFieldsData()
    end
	
	self.nSubStringLength = 40; 
	
	if Steerable.load ~= nil then 
		local orgSteerableLoad = Steerable.load 
		Steerable.load = function(self,xmlFile) 
			orgSteerableLoad(self,xmlFile) 
			for nIndex,sXMLPath in pairs(aNameSearch) do 
				self.name = getXMLString(self.xmlFile, sXMLPath);
				if self.name ~= nil then 
					if self.name == "Locomotive" then
						self.name = g_i18n:getText("helpTitle_59")
					end;
					break; 
				end; 
			end; 
			if self.name == nil then 
				self.name = g_i18n:getText("UNKNOWN")
			end; 
		end;
	end;
	if Attachable.load ~= nil then 
		local orgAttachableLoad = Attachable.load 
		Attachable.load = function(self,xmlFile) 
			orgAttachableLoad(self,xmlFile) 
			for nIndex,sXMLPath 
			in pairs(aNameSearch) 
			do 
				self.name = getXMLString(self.xmlFile, sXMLPath); 
				if self.name ~= nil then 
					break; 
				end; 
			end; 
			if self.name == nil then 
				self.name = g_i18n:getText("UNKNOWN") 
			end; 
		end 
	end; 
end; 

function Inspect17:deleteMap() 

end; 

function Inspect17:mouseEvent(posX, posY, isDown, isUp, button)

end; 

function Inspect17:keyEvent(unicode, sym, modifier, isDown)
	local bChanged = false;
	if isDown and sym == Input.KEY_up and bitAND(modifier, Input.MOD_CTRL) > 0 and bitAND(modifier, Input.MOD_SHIFT) == 0 then 
		if self.bDisplay == 0 then self.bDisplay = 1; 
		else self.bDisplay = 0; 
		end;
		bChanged = true;
	end;
	if isDown and sym == Input.KEY_left and bitAND(modifier, Input.MOD_CTRL) > 0 and bitAND(modifier, Input.MOD_SHIFT) == 0 then
		if self.bDarkColor == 0 then self.bDarkColor = 1;
		else self.bDarkColor = 0;
		end;
		bChanged = true;
	end;
	if isDown and sym == Input.KEY_down and bitAND(modifier, Input.MOD_CTRL) > 0 and bitAND(modifier, Input.MOD_SHIFT) == 0 then
		if self.fPosChanger == 0 then self.fPosChanger = 1;
		else self.fPosChanger = 0;
		end;
		bChanged = true;
	end;
	if isDown and sym == Input.KEY_right and bitAND(modifier, Input.MOD_CTRL) > 0 and bitAND(modifier, Input.MOD_SHIFT) == 0 then
		if self.fDisplayMode == 0 then self.fDisplayMode = 1;
		else
			if self.fDisplayMode == 1 then self.fDisplayMode = 2;
			else
				if self.fDisplayMode == 2 then self.fDisplayMode = 3;
				else self.fDisplayMode = 0;
				end;
			end;
		end;
		bChanged = true;
	end;
	if isDown and sym == Input.KEY_right and bitAND(modifier, Input.MOD_CTRL) > 0 and bitAND(modifier, Input.MOD_SHIFT) > 0 then
		if self.fHighlightMode == 0 then self.fHighlightMode = 1;
		else self.fHighlightMode = 0;
		end;
		bChanged = true;
	end;
	if isDown and (sym == Input.KEY_up or sym == Input.KEY_down) and bitAND(modifier, Input.MOD_CTRL) > 0 and bitAND(modifier, Input.MOD_SHIFT) > 0 then
		if sym == Input.KEY_up then self.fFontSize = self.fFontSize + 0.0005;
		else self.fFontSize = self.fFontSize - 0.0005
		end;
		bChanged = true;
	end;
	if isDown and sym == Input.KEY_left and bitAND(modifier, Input.MOD_CTRL) > 0 and bitAND(modifier, Input.MOD_SHIFT) > 0 then
		if self.fFieldMode == 0 then self.fFieldMode = 1;
		else 
			if self.fFieldMode == 1 then self.fFieldMode = 2;
			else self.fFieldMode = 0;
			end;
		end;
		bChanged = true;
	end;
	if bChanged then Inspect17:saveConfig() end;
end; 

function Inspect17:update(dt) 
	
end; 

function Inspect17:draw() 
	if self.bDisplay == 0 or g_currentMission.ingameMap.isFullSize or Input.keyPressedState[308] then return true; end; 
		
	local fPosY = 0.9225;
	local fPosX = 0.02;
	local helpboxvisible = false
	if g_currentMission.missionInfo.showHelpMenu ~= nil then
		if g_currentMission.missionInfo.showHelpMenu == true then
			helpboxvisible = true
		end;
	end;
	if g_gameSettings:getValue('showHelpMenu') ~= nil then
		if g_gameSettings:getValue('showHelpMenu') == true then
			helpboxvisible = true
		end;
	end;
	
	if helpboxvisible == false or self.fPosChanger == 1 then fPosY = 0.97
	else fPosY = g_currentMission.helpBoxContentOverlay.y - 0.015;
	end;
	
	if self.fPosChanger == 1 then fPosX = 0.03 + g_currentMission.helpBoxWidth
	else fPosX = 0.02
	end;
			
	--local fFontSize = 0.014; 
	local fLineDist = self.fFontSize + 0.002; 
	setTextAlignment(RenderText.ALIGN_LEFT); 
	local nLine = 0; 
	local nVehicles = table.getn(g_currentMission.steerables); 
	if nVehicles > 0 then 
		for i=1,nVehicles do 
			local oVehicle = g_currentMission.steerables[i]; 
			local sLineOutput = ""; 
			setTextBold(false); 
			if self.bDarkColor == 1 then 	setTextColor(0,0,0,1);
			else							setTextColor(1,1,1,1);
			end;
			if oVehicle.showWaterWarning 	then sLineOutput = sLineOutput .. g_i18n:getText("filltype_water") .. "!!! "; end; 
			if oVehicle.beaconLightsActive 	then sLineOutput = sLineOutput .. "!"; end; 
			if oVehicle.isHired 			then sLineOutput = sLineOutput .. "*"; end; 
			if sLineOutput ~= "" 			then sLineOutput = sLineOutput .. " "; end; 
			if oVehicle.isControlled then 
				if oVehicle.controllerName ~= nil then sLineOutput = sLineOutput .. string.sub(Utils.getNoNil(oVehicle.controllerName, g_i18n:getText("UNKNOWN")), 0, 15) .. " / "; end; 
				if g_currentMission.controlledVehicle == oVehicle then setTextBold(true); end; 
			end; 
			
			
			local fieldNummer = nil;
			if self.fFieldMode ~= 2 then
				fieldNummer = Inspect17:getVehicleFieldNumber(oVehicle)
				if fieldNummer ~= nil then fieldNummer = "@ " ..g_i18n:getText("ui_fieldNo") .. " " .. string.format("%2i",fieldNummer) .. " "
				else fieldNummer = "" end;
			end;
			
			if self.fFieldMode == 0 then	sLineOutput = sLineOutput .. string.sub(oVehicle.name, 0, self.nSubStringLength) .. " " .. fieldNummer .. "" .. Inspect17:getSpeed(oVehicle); end;
			if self.fFieldMode == 1 then	sLineOutput = sLineOutput .. string.sub(oVehicle.name, 0, self.nSubStringLength) .. " " .. fieldNummer; end;
			if self.fFieldMode == 2 then	sLineOutput = sLineOutput .. string.sub(oVehicle.name, 0, self.nSubStringLength); end;
						
			local bVeryLowFuel = false;
			if oVehicle.fuelFillLevel ~= nil then
				local nFuelPercentage = oVehicle.fuelFillLevel / oVehicle.fuelCapacity * 100;
				if nFuelPercentage ~= nil then
					if nFuelPercentage >= 0 and nFuelPercentage < 10 then
						sLineOutput = sLineOutput .. "@" .. Inspect17:round(nFuelPercentage) .. "% " .. g_i18n:getText("fillType_fuel") .. " ";
						if nFuelPercentage >= 0 and nFuelPercentage <= 4 then
							setTextColor(1,0,0,1);
							bVeryLowFuel = true;
						end;
					end;
				end;
			end; 
			
			local bSowing = false;
			local bCombine = false
			for nIndex,oImplement in pairs(oVehicle.attachedImplements) 
			do 
				if oImplement ~= nil and oImplement.object ~= nil then 
					local attachement1 = Inspect17:outputAttachement(oImplement, self.nSubStringLength); 
					if oImplement.object.typeName ~= nil then
						if oImplement.object.typeName ~= 'implement' and (self.fDisplayMode == 0 or self.fDisplayMode == 1) then
							sLineOutput = sLineOutput .. attachement1[2];
						end;
					end;
					if oImplement.object.typeName ~= nil then
						if string.find(oImplement.object.typeName, "sowing") or string.find(oImplement.object.typeName, "manure") or string.find(oImplement.object.typeName, "sprayer") then bSowing = true end;
					end;
					
					for nIndex2,oImplement2 in pairs(oImplement.object.attachedImplements) 
					do 
						if oImplement2 ~= nil and oImplement2.object ~= nil then
							local attachement2 = Inspect17:outputAttachement(oImplement2, self.nSubStringLength); 
							if oImplement.object.typeName ~= nil then
								if oImplement.object.typeName ~= 'implement' and (self.fDisplayMode == 0 or self.fDisplayMode == 1) then
									sLineOutput = sLineOutput .. attachement2[2];
								end;
							end;
							if oImplement.object.typeName ~= nil then
								if string.find(oImplement.object.typeName, "sowing") or string.find(oImplement.object.typeName, "manure") or string.find(oImplement.object.typeName, "sprayer") then bSowing = true	end;
							end;
						end;
					end;
				end; 
			end; 
			
			local bVehHasFill = false; 
			local fillLevelInformations = {};
			if oVehicle.getFillLevelInformation ~= nil then
				oVehicle:getFillLevelInformation(fillLevelInformations);
				for i,fillLevelInformation in pairs(fillLevelInformations) do
					if fillLevelInformation.fillLevel > 0 and fillLevelInformation.capacity > 0 then
						bVehHasFill = true;
						local nTankPercentage = Inspect17:getPercentage(fillLevelInformation.capacity, fillLevelInformation.fillLevel); 
						if (nTankPercentage > 0 or bLess == true) then 
							local fillTypeName = FillUtil.fillTypeIntToName[fillLevelInformation.fillType];
							local fillTypeName2 = fillTypeName
							if oVehicle.typeName ~= nil then
								if string.find(oVehicle.typeName, "combine") or string.find(oVehicle.typeName, "PotatoHarvester") then bCombine = true end;
							end;
							fillTypeName = Inspect17:getFillType_new(fillLevelInformation.fillType, "")
							sLineOutput = sLineOutput .. "| " .. fillTypeName .. "@" .. Inspect17:round(nTankPercentage) .. "% "; 
						end; 
						if nTankPercentage >= 80 and ( bCombine == true or ( self.fHighlightMode == 1 and bSowing == false ) ) then setTextColor(1,1,0,1); end; 
						if nTankPercentage <= 10 and bSowing == true then setTextColor(1,1,0,1); end;
					end;
				end;
			end;
			
			if bVehHasFill or oVehicle.isControlled or oVehicle.isHired or bAttachementHasFill or bVeryLowFuel then
				nLine = nLine + 1;
				renderText(fPosX, fPosY-(nLine*fLineDist), self.fFontSize, sLineOutput);
			end;
		end;
	end;
	
	--Animals
	if self.bDarkColor == 1 then 	setTextColor(0,0,0,1);
	else							setTextColor(1,1,1,1);
	end;
	setTextBold(false); 
	local sSheepLineOutput = "";
	local bSheepWarningWool = false;
	local bSheepWarningProductivity = false;
	local bSheepWarningCleanliness = false;
	local sPigLineOutput = "";
	local bPigWarningProductivity = false;
	local bPigWarningCleanliness = false;
	local sCowLineOutput = "";
	local bCowWarningProductivity = false;
	local bCowWarningCleanliness = false;
	
		--Sheep
	if g_currentMission.husbandries.sheep ~= nil then
		if g_currentMission.husbandries.sheep.totalNumAnimals > 0 then
			if g_currentMission.husbandries.sheep.productivity > 0 then
				bSheepWarningProductivity = true;
				sSheepLineOutput = sSheepLineOutput .. g_i18n:getText("statistic_productivity").. "@" .. Inspect17:round(g_currentMission.husbandries.sheep.productivity * 100) .. "% ";
			end;
			if g_currentMission.husbandries.sheep.cleanlinessFactor > 0 then
				bSheepWarningCleanliness = true;
				sSheepLineOutput = sSheepLineOutput .. g_i18n:getText("statistic_cleanliness").. "@" .. Inspect17:round(g_currentMission.husbandries.sheep.cleanlinessFactor * 100) .. "% ";
			end;
			if g_currentMission.husbandries.sheep.currentPallet ~= nil then
				local nPalletFillPercentage = g_currentMission.husbandries.sheep.currentPallet.fillLevel / g_currentMission.husbandries.sheep.currentPallet.capacity * 100;
				if nPalletFillPercentage > 90 then
					bSheepWarningWool = true;
					sSheepLineOutput = sSheepLineOutput .. g_i18n:getText("fillType_wool") .. "@" .. Inspect17:round(nPalletFillPercentage) .. "% ";
				end;
			end;
		end;
	end;
	
	--Pig
	if g_currentMission.husbandries.pig ~= nil then
		if g_currentMission.husbandries.pig.totalNumAnimals > 0 then
			if g_currentMission.husbandries.pig.productivity > 0 then
				bPigWarningProductivity = true;
				sPigLineOutput = sPigLineOutput .. g_i18n:getText("statistic_productivity") .. "@" .. Inspect17:round(g_currentMission.husbandries.pig.productivity * 100) .. "% ";
			end;
			if g_currentMission.husbandries.pig.cleanlinessFactor > 0 then
				bPigWarningCleanliness = true;
				sPigLineOutput = sPigLineOutput .. g_i18n:getText("statistic_cleanliness").. "@" .. Inspect17:round(g_currentMission.husbandries.pig.cleanlinessFactor * 100) .. "% ";
			end;
		end;
	end;
	
	--Cow
	if g_currentMission.husbandries.cow ~= nil then
		if g_currentMission.husbandries.cow.totalNumAnimals > 0 then
			if g_currentMission.husbandries.cow.productivity > 0 then
				bCowWarningProductivity = true;
				sCowLineOutput = sCowLineOutput .. g_i18n:getText("statistic_productivity") .. "@" .. Inspect17:round(g_currentMission.husbandries.cow.productivity * 100) .. "% ";
			end;
			if g_currentMission.husbandries.cow.cleanlinessFactor > 0 then
				bCowWarningCleanliness = true;
				sCowLineOutput = sCowLineOutput .. g_i18n:getText("statistic_cleanliness").. "@" .. Inspect17:round(g_currentMission.husbandries.cow.cleanlinessFactor * 100) .. "% ";
			end;
		end;
	end;
	
	-- Animal Output
	if self.fDisplayMode == 0 or self.fDisplayMode == 2 then
		if bSheepWarningProductivity or bSheepWarningWool or bSheepWarningCleanliness or bCowWarningProductivity or bCowWarningCleanliness or bPigWarningProductivity or bPigWarningCleanliness then nLine = nLine + 1; end;
		
		if bSheepWarningProductivity or bSheepWarningWool then 
			if bSheepWarningWool then setTextColor(1,1,0,1); end;
			nLine = nLine + 1; 
			sSheepLineOutput = g_i18n:getText("animals_sheepPasture") .. ": " .. sSheepLineOutput; 
			renderText(fPosX, fPosY-(nLine*fLineDist), self.fFontSize, sSheepLineOutput); 
			if self.bDarkColor == 1 then 	setTextColor(0,0,0,1);
			else							setTextColor(1,1,1,1);
			end;
		end;
		
		if bPigWarningProductivity then 
			nLine = nLine + 1; 
			sPigLineOutput = g_i18n:getText("animals_pigPasture") .. ": " .. sPigLineOutput; 
			renderText(fPosX, fPosY-(nLine*fLineDist), self.fFontSize, sPigLineOutput); 
		end;
		
		if bCowWarningProductivity then 
			nLine = nLine + 1; 
			sCowLineOutput = g_i18n:getText("animals_cowPasture") .. ": " .. sCowLineOutput; 
			renderText(fPosX, fPosY-(nLine*fLineDist), self.fFontSize, sCowLineOutput); 
		end;
	end;
end;

function Inspect17:loadConfig()
	local SettingsXml;
	local file = g_modsDirectory.."/Inspect17_config.xml";
	local bTest = true;
	
	if self.isDedi then 
		if fileExists(file) then
			deleteFile(file)
		end;
		return true;
	end;
	
	if fileExists(file) then
		hudXml = loadXMLFile("Inspect_XML", file, "Inspect");
		local Display       = getXMLFloat(hudXml, "Inspect.Settings.Display");
		local DarkColor     = getXMLFloat(hudXml, "Inspect.Settings.DarkColor");
		local PosChanger    = getXMLFloat(hudXml, "Inspect.Settings.Position");
		local DisplayMode   = getXMLFloat(hudXml, "Inspect.Settings.DisplayMode");
		local FieldMode   = getXMLFloat(hudXml, "Inspect.Settings.FieldMode");
		local HighlightMode = getXMLFloat(hudXml, "Inspect.Settings.HighlightMode");
		local FontSize      = getXMLFloat(hudXml, "Inspect.Settings.FontSize");
		if Display == nil then setXMLFloat(hudXml, "Inspect.Settings.Display",self.bDisplay); end;
		if DarkColor == nil then setXMLFloat(hudXml, "Inspect.Settings.DarkColor",self.bDarkColor);	end;
		if PosChanger == nil then setXMLFloat(hudXml, "Inspect.Settings.PosChanger",self.fPosChanger); end;
		if DisplayMode == nil then setXMLFloat(hudXml, "Inspect.Settings.DisplayMode",self.fDisplayMode); end;
		if FieldMode == nil then setXMLFloat(hudXml, "Inspect.Settings.FieldMode",self.fFieldMode); end;
		if HighlightMode == nil then setXMLFloat(hudXml, "Inspect.Settings.HighlightMode",self.fHighlightMode);	end;
		if FontSize == nil then setXMLFloat(hudXml, "Inspect.Settings.FontSize",self.fFontSize); end;
		saveXMLFile(hudXml);
	else
		hudXml = createXMLFile("Inspect_XML", file, "Inspect");
		setXMLFloat(hudXml, "Inspect.Settings.Display",self.bDisplay);
		setXMLFloat(hudXml, "Inspect.Settings.DarkColor",self.bDarkColor);
		setXMLFloat(hudXml, "Inspect.Settings.Position",self.fPosChanger);
		setXMLFloat(hudXml, "Inspect.Settings.DisplayMode",self.fDisplayMode);
		setXMLFloat(hudXml, "Inspect.Settings.FieldMode",self.fFieldMode);
		setXMLFloat(hudXml, "Inspect.Settings.HighlightMode",self.fHighlightMode);
		setXMLFloat(hudXml, "Inspect.Settings.FontSize",self.fFontSize);
		saveXMLFile(hudXml);
	end;
	if hudXml ~= nil then	
		self.bDisplay     = getXMLFloat(hudXml, "Inspect.Settings.Display");
		self.bDarkColor   = getXMLFloat(hudXml, "Inspect.Settings.DarkColor");
		self.fPosChanger  = getXMLFloat(hudXml, "Inspect.Settings.Position");
		self.fDisplayMode = getXMLFloat(hudXml, "Inspect.Settings.DisplayMode");
		self.fFieldMode = getXMLFloat(hudXml, "Inspect.Settings.FieldMode");
		self.fHighlightMode = getXMLFloat(hudXml, "Inspect.Settings.HighlightMode");
		self.fFontSize = getXMLFloat(hudXml, "Inspect.Settings.FontSize");
	end;
end;

function Inspect17:saveConfig()
	local SettingsXml;
	local file = g_modsDirectory.."/Inspect17_config.xml";
	if self.isDedi then 
		return true;
	end;
			
	if fileExists(file) then	hudXml = loadXMLFile("Inspect_XML", file, "Inspect");
	else						hudXml = createXMLFile("Inspect_XML", file, "Inspect");
	end;
	
	setXMLFloat(hudXml, "Inspect.Settings.Display",self.bDisplay);
	setXMLFloat(hudXml, "Inspect.Settings.DarkColor",self.bDarkColor);
	setXMLFloat(hudXml, "Inspect.Settings.Position",self.fPosChanger);
	setXMLFloat(hudXml, "Inspect.Settings.DisplayMode",self.fDisplayMode);
	setXMLFloat(hudXml, "Inspect.Settings.FieldMode",self.fFieldMode);
	setXMLFloat(hudXml, "Inspect.Settings.HighlightMode",self.fHighlightMode);
	setXMLFloat(hudXml, "Inspect.Settings.FontSize",self.fFontSize);
	saveXMLFile(hudXml);
end;				

function Inspect17:outputAttachement(oImplement, nMaxStringLength) 
	local oImplementObject = oImplement.object;
	local bAttachementHasFill = false;
	local attachementString = '';
	local sTempOutput = ''; 
	if oImplementObject.name ~= nil then 
		if string.find(oImplementObject.name, "l10n") then 
			attachementString = g_i18n:getText(string.sub(oImplementObject.name,7))
			if string.find(attachementString, "Missing") then
				sTempOutput = sTempOutput .. "| " .. g_i18n:getText("UNKNOWN"); 
			else
				sTempOutput = sTempOutput .. "| " .. attachementString
			end;
		else
			sTempOutput = sTempOutput .. "| " .. string.sub(oImplementObject.name, 0, nMaxStringLength) .. " "; 
		end;
	end; 
	return {bAttachementHasFill, sTempOutput}; 
end; 

function Inspect17:getFillType_new(fillType, implementTypeName)
	local sFillType = g_i18n:getText("UNKNOWN");
	if FillUtil.fillTypeIndexToDesc[fillType] ~= nil then
		local output1 =  FillUtil.fillTypeIndexToDesc[fillType].nameI18N
		if string.find(output1, "Missing") then
			sFillType = g_i18n:getText("UNKNOWN"); 
		else
			sFillType = output1;
		end;
	end;
	return sFillType;
end;

function Inspect17:round(num, idp)
	if Utils.getNoNil(num, 0) > 0 then 
		local mult = 10^(idp or 0); 
		return math.floor(num * mult) / mult; 
	else 
		return 0; 
	end; 
end; 

function Inspect17:checkIsDedi()
	return g_dedicatedServerInfo ~= nil;
end;

function Inspect17:getPercentage(capacity, level) 
	return level / capacity * 100; 
end;

function Inspect17:getVehicleFieldNumber(oVehicle)
	if oVehicle.components and oVehicle.components[1] and oVehicle.components[1].node then
		local vx,_,vz = getWorldTranslation(oVehicle.components[1].node);

		if vx~=vx or vz~=vz then 
			return;
		end;
	  
		local nearestField = nil;
		for fieldNum,fieldData in ipairs(Inspect17.fieldsData) do
			for _,coords in ipairs(fieldData) do
				if  coords.x1 <= vx and vx <= coords.x2 and coords.z1 <= vz and vz <= coords.z2 then
					nearestField = fieldNum;
					break;
				end;
			end;
			if nearestField ~= nil then return nearestField	end;
		end;
	end;
end;

function Inspect17.buildFieldsData()
    local function getFieldData(field)
		local coords = {}
		if field ~= nil and field.fieldDimensions ~= nil then
			for i = 0, getNumOfChildren(field.fieldDimensions) - 1 do
				local n1 = getChildAt(field.fieldDimensions, i);
				local n2 = getChildAt(n1, 0);
				local n3 = getChildAt(n1, 1);
				local c1 = { getWorldTranslation(n1) };
				local c2 = { getWorldTranslation(n2) };
				local c3 = { getWorldTranslation(n3) };
				local overlap = 10;
				local x1 = math.min(c1[1],c2[1],c3[1]) - overlap;
				local z1 = math.min(c1[3],c2[3],c3[3]) - overlap;
				local x2 = math.max(c1[1],c2[1],c3[1]) + overlap;
				local z2 = math.max(c1[3],c2[3],c3[3]) + overlap;
				table.insert(coords, {x1=x1,z1=z1,x2=x2,z2=z2});
			end;
		end;
		return coords;
	end;

    if  g_currentMission.fieldDefinitionBase ~= nil and g_currentMission.fieldDefinitionBase.fieldDefs ~= nil then
        for fieldNum,fieldDef in ipairs(g_currentMission.fieldDefinitionBase.fieldDefs) do
            Inspect17.fieldsData[fieldNum] = getFieldData(fieldDef)
        end
    end
end

function Inspect17:getSpeed(oVehicle)
	local speed	= oVehicle.lastSpeed;
	local speedunit = "";
	if g_gameSettings:getValue('useMiles') then speedunit= g_i18n:getText("unit_mph");
	else speedunit = g_i18n:getText("unit_kmh");
	end;
	if speed == nil then return '';
	else
		speed = speed * 3600;
		if g_gameSettings:getValue('useMiles') then speed = speed * 0.621388 end;
		return  "(" .. string.format("%.1f %s",speed, speedunit).. ")";
	end;
end

addModEventListener(Inspect17);